# Hoofdstuk-25-listing2510--OPLOSSINGEN.py -- 2 opgaven
# Uit Pieter Spronck: De programmeursleerling
# Variant door Meindert Meindertsma, 2023-05-22


import re

# List van strings die worden gebruikt voor testen.
slist = [ "Monty Python's Flying Circus", "aaaa", "aabb", "abab", "abba" ]

# Reguliere expressies die moeten worden ingevuld.
relist = [
    None,
    r"(.).*\1.*\1",      # 1. Willekeurig teken dat 3 keer voorkomt
    r"(..).*\1",         # 2. Willekeurig tekenpaar dat 2 keer voorkomt
    r"((.)(?!\2).).*\1"  # 3. Willekeurig verschillend tekenpaar
                         #    dat 2 keer voorkomt
]

# Uitgesplitste presentatie.
for i in range(1, len( relist ) ):
# for i in (1,):
    print( f'Reguliere expressie {i} = "{relist[i]}":' )
    for s in slist:
        if m := re.search( relist[i], s ):
            gevonden = f'segment [{m.start(0)}:{m.end(0)}] = "{m.group(0)}"' \
                       f' voldoet'
        else:
            gevonden = ""
        print( f'''   {f'"{s}"' :19s}:''', gevonden )
    print()

