# Hoofdstuk-25-listing2510alt--OPLOSSINGEN.py -- 2 opgaven
# Uit Pieter Spronck: De programmeursleerling
# Oplossingen door Meindert Meindertsma, 2023-05-23


import re

def verwerk( titel, patroon ):
    print( "   ", titel, f'-- patroon = "{patroon}":')
    for m in re.finditer( patroon, tekst ):
        print( "       ", m, f'"{m.group(1)}"' if len(m.groups()) > 0 else '' )

#------------------------------------------------------------------------------#
"""
Opgave: Kun je de reguliere expressie in de code hieronder zo wijzigen dat het een
patroon beschrijft waarbij een willekeurig teken minimaal drie keer voorkomt?
"""
tekst = "Monty Python's Flying Circus"
print( f'Tekst = "{tekst}"' )

verwerk( "1e opgave", r"(.).*?\1.*?\1" )

#------------------------------------------------------------------------------#
"""
Opgave: Kun je de reguliere expressie wijzigen zodat het een patroon beschrijft waarbij
twee tekens twee keer voorkomen? Dit is behoorlijk moeilijk en daarom optioneel, maar
als je het probeert, zorg er dan voor dat je het test met op zijn minst de strings "aaaa",
"aabb", "abab" and "abba". Deze moeten allemaal een match geven, tenzij je ook nog eist
dat de twee tekens verschillend moeten zijn, in welk geval "aaaa" geen match mag geven
(maar dat maakt de reguliere expressie nog eens een stuk moeilijker).
"""
tekst += " aaaa aabb abab abba"
print( f'\nTekst = "{tekst}"' )

verwerk( "2e opgave, GREEDY, willek. non-spatiepaar"        , r"(\S\S).*\1" )

verwerk( "2e opgave, idem NON-GREEDY"                       , r"(\S\S).*?\1" )

verwerk( "2e opgave, GREEDY, willek. versch. non-spatiepaar", r"((\S)(?!\2)\S).*\1" )

verwerk( "2e opgave, idem NON-GREEDY"                       , r"((\S)(?!\2)\S).*?\1" )

